/* To add:
	- Preferences setting and storing
	- Checking for updates
*/

var glassDoneButton, closeButton;
var whiteInfoButton;
var mainScrollArea, mainScrollbar;
var detailsScrollArea, detailsScrollbar;

var calendarStyle = "old";
var checkForUpdates = true;
var today;
var vitaeDoc;
var feasts;
var skipVersion;
var updateVersion;

var thisVersion = "0.1";

var lastUpdated = null;
var xmlRequest = null;
var updateXmlRequest = null;

var site = "http://www.stjohnthebaptist.org.au/";
var contentUrl = site + "saints/";
var updateUrl = site + "downloads/dashboard-widget/version.xml";
var downloadUrl = site + "downloads/index.html";

function load() {
	// Set up GUI
	// front
	whiteInfoButton = new AppleInfoButton(document.getElementById("infoButton"), 
		document.getElementById("front"), "white", "white", showPrefs);
	mainScrollbar = new AppleVerticalScrollbar( 
		document.getElementById("mainScrollbar"));
	mainScrollArea = new AppleScrollArea(document.getElementById("contents"), 
		mainScrollbar);
	mainScrollArea.scrollsHorizontally = false;
	mainScrollArea.singlepressScrollPixels = 15;
	
	// Details
	closeButton = new AppleGlassButton( 
		document.getElementById("closeButton"), "Close", hideDetails);
	detailsScrollbar = new AppleVerticalScrollbar( 
		document.getElementById("detailsScrollbar"));
	detailsScrollArea = new AppleScrollArea( 
		document.getElementById("detailsContent"), detailsScrollbar);
	detailsScrollArea.scrollsHorizontally = false;
	detailsScrollArea.singlepressScrollPixels = 15;

	// reverse side
	glassDoneButton = new AppleGlassButton( 
		document.getElementById("doneButton"), "Done", hidePrefs)
		
	// update dialogue
	closeButton = new AppleGlassButton( 
		document.getElementById("updateOK"), "Download", gotoUpdate);	
	closeButton = new AppleGlassButton( 
		document.getElementById("updateSkip"), "Skip", skipUpdate);	
		
	// Get preferences
	
	if (window.widget) {
		var calendarStylePref = widget.preferenceForKey(makeKey("calendar"));
		if (calendarStylePref && calendarStylePref.length > 0)
			calendarStyle = calendarStylePref;
			
		var updatesPref = widget.preferenceForKey(makeKey("updates"));
		if (updatesPref && updatesPref.length > 0)
			checkForUpdates = (updatesPref == 'yes') ? true : false;

		var prefVersion = widget.preferenceForKey(makeKey("version"));
		if (prefVersion && prefVersion.length > 0)
			skipVersion = prefVersion;
	} // if (window.widget)

	update(true);
}

function update(force) {
	var totalDays = new Array (30, 31, 30, 31, 31, 29, 31, 30, 31, 30 , 31, 31);
	var days = new Array ("Sunday", "Monday", "Tuesday", "Wednesday",
		"Thursday", "Friday", "Saturday");
	var months = new Array ("September", "October", "November", "December",
		"January", "February", "March", "April", "May", "June", "July",
		"August");		
		
 	var todayNS = new Date();

/*	if (lastUpdated) return;
	lastUpdated = true;*/
	
 	if ((lastUpdated == todayNS.getDate()) && !force)
 		return;
	lastUpdated = todayNS.getDate();
	if (checkForUpdates) checkForUpdate();
	document.getElementById("updating").style.display = "block";
 	
 	today = {};
	today.month = (todayNS.getMonth() + 4 ) % 12 + 1; // Month, 1-up, Sep is 1
	today.date = todayNS.getDate(); // day of month, 1-up
	var day = todayNS.getDay(); // day of week, 0-up
	var year = todayNS.getFullYear();
	var dateStr = "";
	
	if (calendarStyle == "old") { // Convert to Church calendar
		var dateNS = today.date;
		var monthNS = today.month;
		var yearNS = year;
		today.date -= 13;
		if (today.date < 1) {
			today.month--;
			if (today.month < 1)
				today.month = 12;
			if (today.month == 4) // December
				year--;
			today.date += totalDays[today.month-1];
		}
		if (today.month == monthNS)
			dateStr = days[day] + ", " + today.date + " / " + dateNS + " " + 
				months[today.month-1] + " " + year;
		else if (year == yearNS)
			dateStr = days[day] + ", " + today.date + " " + months[today.month-1] + " / " + 
				dateNS + " " + months[monthNS-1] + " " + year;
		else
			dateStr = days[day] + ", " + today.date + " " + months[today.month-1] + year + 
				" / " + dateNS + " " + months[monthNS-1] + " " + yearNS;
	} else { // new style calendar
		dateStr = days[day] + ", " + today.date + " " + months[today.month-1] + " " + year;
	}
	var dateElement = document.getElementById("date");
	dateElement.innerText = dateStr;
	
	if (xmlRequest != null) {
		xmlRequest.abort();
		xmlRequest = null;
	}
	
	xmlRequest = new XMLHttpRequest();
	url = contentUrl + "day.php?month=" + today.month + "&day=" + today.date + 
		"&mode=xml";
	xmlRequest.onload = function(e) {xmlLoaded(e, xmlRequest);}
	xmlRequest.overrideMimeType("text/xml");
	xmlRequest.open("GET", url);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.send(null);
}

function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";

	document.getElementById("updates").checked = checkForUpdates;

	document.getElementById(calendarStyle).checked = true;
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);

	//document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
}

function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";

	checkForUpdates = document.getElementById("updates").checked;
	
	if (window.widget) {
		widget.setPreferenceForKey(checkForUpdates ? 'yes' : 'no', makeKey("updates"));
		widget.setPreferenceForKey(calendarStyle, makeKey("calendar"));
		setTimeout('widget.performTransition();', 0);
		setTimeout('update(true);',2000);
	} else
		update(true);
}

function hideDetails() {
	document.getElementById("details").style.display = "none";
}

// makeKey makes the widget multi-instance aware

function makeKey(key) {
	return (widget.identifier + "-" + key);
}

// Handle widget events

function removed() {
	widget.setPreferenceForKey(null,makeKey("updates"));
	widget.setPreferenceForKey(null,makeKey("version"));
	widget.setPreferenceForKey(null,makeKey("calendar"));
}

function focused() {
	mainScrollArea.focus(); 
	update(false);
//	document.getElementById('worldText').style.color = 'white'; 
}

function blurred() {
	mainScrollArea.blur();
//	document.getElementById('worldText').style.color = 'gray'; 
}

function clickOnHomeLink() {
	var homeUrl = site;
	if (window.widget) {
			widget.openURL(homeUrl);
	} else
		document.location = homeUrl;
}

function findChild(element, nodeName) {
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling) {
		if (child.nodeName == nodeName)
			return child;
	}	
	return null;
}

// Return the value associated with a key in a property list

function getKeyValue(dict, key) {
	var element;
	
	for (element = dict.firstChild; element != null; element = element.nextSibling) {
		if (element.nodeName == "key" && element.firstChild.data == key)
			return element.nextSibling.firstChild.data;
	}
	return null;
}

function xmlLoaded(e, httpRequest) {
	try {
		if (httpRequest.readyState == 4) {
			if (httpRequest.status == 200) {
				xmlRequest = null;
				if (httpRequest.responseXML) {		
					vitaeDoc = document.getElementById('contents');
					while (vitaeDoc.hasChildNodes())
						vitaeDoc.removeChild(contents.firstChild);
					
					// Get the top level <vitae> element 
					var vitae = findChild(httpRequest.responseXML, 'vitae');
					if (!vitae) {
						document.getElementById("updating").style.display = "none";
						document.getElementById("ohnoes").style.display = "block";
						lastUpdated = null;
						return;
					}
					
					// Get single subordinate <day> element
					var day = findChild( vitae, 'day');
					if (!day) {
						document.getElementById("ohnoes").style.display = "block";
						return;
					}
							
					document.getElementById("ohnoes").style.display = "none";
			
					// save feasts for later use
					feasts = day.getElementsByTagName("feast");
			
					var results = new Array;
					
					for( var item = day.firstChild; item != null; item = item.nextSibling) {
						if (item.nodeName == 'feast')  {
							var name = findChild (item, 'name');
						
							// we have to have the title to include the item in the list 
							if (name != null)  {
								var link = contentUrl;				
								//var link = contentUrl + "day.php?month=" + month + "&day=" + day + "&mode=xhtmlFragment";
								//var link = findChild (item, 'link');
								//var pubDate = findChild (item, 'pubDate');
								results[results.length] = {name: name.firstChild.data,
									link: results.length};
								//results[results.length] = {name: "test", link: "linktest"
							   };
							} else if (item.nodeName == 'commemoration') {
							results[results.length] = {name: item.firstChild.data, 
									link: null};
						}
					}
					
					// copy title and date into rows for display. Store link so it can be used when user
					// clicks on title
					nItems = results.length;	
					for (var i = 0; i < nItems; ++i) {
						var item = results[i];
						var row = createRow(item.name, item.link);
						contents.appendChild(row);
					}
			
					document.getElementById("updating").style.display = "none";
			
					// update the scrollbar so scrollbar matches new data
					mainScrollArea.refresh();
				}
			} else { // request is ready but response was not OK
				alert("Nework error (" + httpRequest.status + "): " + httpRequest.statusText);
			}
		} // readyState
	} catch(httpException) {
		alert(httpException.name + " (" + httpException.number + "): " + httpException.message);
	}
}

function createRow(name, link) {
	var row = document.createElement('div');
	row.setAttribute("class","row");
	var titleDiv = document.createElement('div');
	var titleText = document.createTextNode(name);
	titleDiv.appendChild(titleText);
	//titleDiv.innerText = name;
	titleDiv.setAttribute('class', 'title');
	if (link != null) {
		titleDiv.setAttribute('ref', link);
		titleDiv.setAttribute('class', "titleLink");
		titleDiv.setAttribute('onclick', 'clickOnTitle (event, this);');
	}
	
	row.appendChild(titleDiv);
	
	return row;	
}

function clickOnTitle(event, div) {
	if (div.ref == "") // commemoration
		return;
		
	var feast = feasts[div.ref];
	var details = document.getElementById("details");
	var detailsContent = document.getElementById("detailsContent");
	
	// Remove current content
	while(detailsContent.hasChildNodes())
		detailsContent.removeChild(detailsContent.firstChild);
	
	var heading = document.getElementById("detailsHeading");
	while(heading.hasChildNodes())
		heading.removeChild(heading.firstChild);	
	var headingText = document.createTextNode(
		feast.getElementsByTagName("name").item(0).firstChild.data);
	heading.appendChild(headingText);
	
	// Get the text and prayers
	var element = feast.firstChild;
	while (element) {
		var node = element.nodeName;
		switch (node) {
			case "text":
			case "troparion":
			case "kontakion":
			case "prayer":
				createPara(element,node);
			break;
		}
		element = element.nextSibling;
	}
	//var textElements = feast.getElementsByTagName("text");
		
	details.style.display = "block";
	detailsScrollArea.refresh();
}

function createPara(element, type) {
	var detailsContent = document.getElementById("detailsContent");
	var j;
	var para = document.createElement("p");
	para.setAttribute("class",type);
	var textNodes = element.childNodes;
	var textStr = "";
	for (j = 0; j < textNodes.length; j++) {
		textNode = textNodes.item(j);
		if ( textNode.nodeType == Node.TEXT_NODE)
			textStr += textNode.data;
	}
	var text = document.createTextNode(textStr);
	para.appendChild(text);
	detailsContent.appendChild(para);
}

function clickOnWidgetTitle() {
	if (window.widget)
		widget.openURL (contentUrl);
	else
		document.location = contentUrl;
}

function changeCalendar(radio) {
	calendarStyle = radio.value;
//	update(true);
}

// Check for new version

function checkForUpdate() {
	if (updateXmlRequest != null) {
		updateXmlRequest.abort();
		updateXmlRequest = null;
	}
	
	updateXmlRequest = new XMLHttpRequest();
	updateXmlRequest.onload = function(e) { updateXmlLoaded(e, updateXmlRequest);}
	updateXmlRequest.overrideMimeType("text/xml");
	updateXmlRequest.open("GET", updateUrl);
	updateXmlRequest.setRequestHeader("Cache-Control", "no-cache");
	updateXmlRequest.send(null);
}

// Handle new version XML response

function updateXmlLoaded(e, httpRequest) {
	try {
		if (httpRequest.readyState == 4) {
			if (httpRequest.status == 200) {
				updateXmlRequest = null;
				if (httpRequest.responseXML) {		
					// Get the top level element 
					var versionElement = findChild(httpRequest.responseXML, 'version');
					if (!versionElement) {
						return;
					}
					// Get version element
					var version = versionElement.firstChild.data; // assume no spaces etc.
					if (version != thisVersion) {
						if (skipVersion)
							if (version == skipVersion)
								return;
						document.getElementById("update").style.display = "block";
						updateVersion = version;
					}
				}
			} else { // request is ready but response was not OK
				alert("Nework error (" + httpRequest.status + "): " + httpRequest.statusText);
			}
		} // readyState
	} catch(httpException) {
		alert(httpException.name + " (" + httpException.number + "): " + httpException.message);
	}
}

function gotoUpdate() {
	if (window.widget)
		widget.openURL(downloadUrl);
	else
		document.location = downloadUrl;
		
	document.getElementById("update").style.display = "none";
}

function skipUpdate() {
	skipVersion = updateVersion;
	if (window.widget)
		widget.setPreferenceForKey(skipVersion, makeKey("version"));
	document.getElementById("update").style.display = "none";
}

// Register for widget events

if (window.widget) {
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
	widget.onshow = update;
}	
